// IMatchFinder.cs

using System;
using Windows.Storage.Streams;
using System.IO;
using System.Collections.Generic;

namespace WinRT.BxlComponent.SevenZip.Compression.LZ
{
	public interface IInWindowStream
	{
        //void SetStream(System.IO.Stream inStream);
        void SetStream(IRandomAccessStream inStream);
        void Init();
		void ReleaseStream();
		Byte GetIndexByte(Int32 index);
		UInt32 GetMatchLen(Int32 index, UInt32 distance, UInt32 limit);
		UInt32 GetNumAvailableBytes();
	}

	public interface IMatchFinder : IInWindowStream
	{
		void Create(UInt32 historySize, UInt32 keepAddBufferBefore,
				UInt32 matchMaxLen, UInt32 keepAddBufferAfter);
		UInt32 GetMatches(IList<UInt32> listDistances);
		void Skip(UInt32 num);
	}
}
